Layers in JavaScript Diagram control

Layer organizes related shapes within a diagram control as named categories. Assigning shapes to different layers enables selective viewing, removal, and locking of distinct shape categories.

In a diagram, Layers facilitate the modification of properties for all shapes assigned to a specific layer. Key properties that can be configured include:

  • Objects
  • Visible
  • Lock
  • AddInfo

Objects

The layer’s objects property specifies which diagram elements belong to that layer. This property contains a collection where you can define the categories of nodes and connectors that the layer encompasses.

In the following example, the basic shapes are categorized in layer 1, and the flow shapes are categorized in layer 2.

// A node is created and stored in nodes array.
var nodes = [
    // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Rectangle' },
      annotations: [{ content: 'Basic rectangle' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 250,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Ellipse' },
      annotations: [{ content: 'Basic Ellipse' }],
    },
    {
      id: 'node3',
      width: 100,
      height: 100,
      offsetX: 400,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'RightTriangle' },
      annotations: [{ content: 'Basic RightTriangle' }],
    },
    {
      id: 'node4',
      width: 100,
      height: 100,
      offsetX: 550,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Plus' },
      annotations: [{ content: 'Basic Plus' }],
    },
  
    // Layer 2 Nodes
  
    {
      id: 'node5',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Terminator' },
      annotations: [{ content: 'Flow Terminator' }],
    },
    {
      id: 'node6',
      width: 100,
      height: 100,
      offsetX: 250,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Process' },
      annotations: [{ content: 'Flow Process' }],
    },
    {
      id: 'node7',
      width: 100,
      height: 100,
      offsetX: 400,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Decision' },
      annotations: [{ content: 'Flow Decision' }],
    },
    {
      id: 'node8',
      width: 100,
      height: 100,
      offsetX: 550,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Document' },
      annotations: [{ content: 'Flow Document' }],
    },
  ];
  // initialize diagram component
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: nodes,
      layers: [
        {
          id: 'layer1',
          //Layer 1 objects
          objects: ['node1', 'node2', 'node3', 'node4'],
        },
        {
          id: 'layer2',
          //Layer 2 objects
          objects: ['node5', 'node6', 'node7', 'node8'],
        },
      ],
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Visible

The layer’s visible property is used to control the visibility of the elements assigned to the layer. You can hide objects in one layer while showing objects in another layer.

In the following example, the visibility of layer one is set to false. By default, the visible property of a layer is set to true.

// A node is created and stored in nodes array.
  var nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];
  var connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];
  // initialize diagram component
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      connectors: connectors,
      nodes: nodes,
      layers: [
        {
          id: 'layer1',
          //Layer 1 visibility set as false.
          visible: false,
          objects: ['node1'],
        },
        {
          id: 'layer2',
          visible: true,
          objects: ['node2', 'connector1'],
        },
      ],
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Lock

The layer’s lock property is used to prevent or allow changes to the element’s dimensions and positions. Locking a layer prevents any interactions with the objects in that layer, such as selecting, dragging, rotating, and connecting.

In the following example the objects in layer one is locked. By default, the lock property of a layer is set to false.

// A node is created and stored in nodes array.
var nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [
        {
          content: 'Layer 1 object Locked',
        },
      ],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      annotations: [
        {
          content: 'Layer 2 Object',
        },
      ],
    },
  ];
  var connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [
        {
          content: 'Layer 2 Object',
        },
      ],
    },
  ];
  // initialize diagram component
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      connectors: connectors,
      nodes: nodes,
      layers: [
        {
          id: 'layer1',
          visible: true,
          objects: ['node1'],
          //Locks the layer1 and prevents any interactions to the objects in layer1
          lock: true,
        },
        {
          id: 'layer2',
          visible: true,
          objects: ['node2', 'connector1'],
          lock: false,
        },
      ],
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

AddInfo

The addInfo property of layers allow you to maintain additional information to the layers.

The following code illustrates how to add additional information to the layers.

var nodes = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
    }
];
var connectors = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 300
    },
    targetPoint: {
        x: 200,
        y: 400
    },
}];
//Additional informations of layer
var addInfo = { Description: 'Layer1' };
// initialize Diagram component
var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '600px',
    connectors: connectors,
    nodes: nodes,
    layers: [{
            id: 'layer1',
            visible: true,
            objects: ['node1', 'node2'],
            addInfo: addInfo
        },
        {
            id: 'layer2',
            visible: true,
            objects: ['connector1']
        }
    ]
});

Add layer at runtime

Layers can be added at runtime using the addLayer public method.

The layer’s id property defines the ID of the layer, which is used to find the layer at runtime and apply any customizations. You can also add new objects to the new layer using the addLayer method.

The following code illustrates how to add a new layer with new connectors stored in an object array of the new layer:

// A node is created and stored in nodes array.
var nodes = [
    // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
  
    // Layer 2 Nodes
  
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];
  // initialize diagram component
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '600px',
      nodes: nodes,
      layers: [
        {
          id: 'layer1',
          //Layer 1 objects
          objects: ['node1'],
        },
        {
          id: 'layer2',
          //Layer 2 objects
          objects: ['node2'],
        },
      ],
    },
    '#element'
  );
  
  document.getElementById('addLayer').onclick = () => {
    let newLayer = {
      id: 'newlayer',
      visible: true,
      lock: false,
    };
    let layerObject = [
      {
        id: 'con1',
        type: 'Straight',
        sourceID: 'node1',
        targetID: 'node2',
      },
    ];
    /**
     * Add the layers to the existing diagram layer collection
     * newLayer - representing the layer to be added to the diagram.
     * layerObject -  An optional array of objects associated with the layer.
     */
    diagram.addLayer(newLayer, layerObject);
  };
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="addLayer" id="addLayer" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Remove layer at runtime

Layers can be removed at runtime by using the removeLayer public method.

To remove a layer, pass the ID of the layer you want to remove as a parameter to the removeLayer method.

The following code illustrates how to remove a layer.

// A node is created and stored in nodes array.
var nodes = [
  // Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    annotations: [{ content: 'Layer 2 Object' }],
  },
];
// initialize diagram component
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: nodes,
    layers: [
      {
        id: 'layer1',
        //Layer 1 objects
        objects: ['node1'],
      },
      {
        id: 'layer2',
        //Layer 2 objects
        objects: ['node2'],
      },
    ],
  },
  '#element'
);

document.getElementById('removeLayer').onclick = () => {
  var layerId = 'layer1';
  /**
   * Remove the layer from the existing diagram layer collection
   * layerId - representing the id of the layer to be removed from the diagram.
   */
  diagram.removeLayer(layerId);
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="removeLayer" id="removeLayer" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

moveObjects

You can move objects from one layer to another dynamically using the moveObjects public method of the diagram control. This can be useful for managing complex diagrams with multiple layers where you need to update the categorization of elements based on user interaction or other dynamic conditions..

The following code illustrates how to move objects from one layer to another layer.

// A node is created and stored in nodes array.
var nodes = [
  // Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 300,
    annotations: [{ content: 'Layer 2 Object' }],
  },
];
// initialize diagram component
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: nodes,
    layers: [
      {
        id: 'layer1',
        //Layer 1 objects
        objects: ['node1', 'node2'],
      },
      {
        id: 'layer2',
        //Layer 2 objects
        objects: ['node3'],
      },
    ],
  },
  '#element'
);

document.getElementById('moveObjects').onclick = () => {
  /**
   * Move objects from one layer to another layern
   * Parameter 1 - An array of object IDs represented as strings to be moved
   * parameter 2 -  The ID of the target layer to which the objects should be moved.
   */
  diagram.moveObjects(['node1'], 'layer2');
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="moveObjects" id="moveObjects" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Z-Index

zIndex property of a layer defines its Z order within the diagram. This property allows you to control the layer’s position in the stacking order. You can adjust the layer’s z-index by moving it forward or backward relative to other layers in the diagram.

Bring Layer Forward

Layers can be moved forward at runtime by using the bringLayerForward public method.

// move the layer forward
diagram.bringLayerForward('layer1');

Send Layer Backward

Layers can be moved backward at runtime by using the sendLayerBackward public method.

// move the layer backward
diagram.sendLayerBackward('layer1');

The following code illustrates how to send the layer forward/backward to another layer.

// A node is created and stored in nodes array.
var nodes = [
  // Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 130,
    offsetY: 130,
    annotations: [{ content: 'Layer 2 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 160,
    offsetY: 160,
    annotations: [{ content: 'Layer 3 Object' }],
  },
];
// initialize diagram component
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: nodes,
    layers: [
      {
        id: 'layer1',
        //Layer 1 objects
        objects: ['node1'],
      },
      {
        id: 'layer2',
        //Layer 2 objects
        objects: ['node2'],
      },
      {
        id: 'layer3',
        //Layer 2 objects
        objects: ['node3'],
      },
    ],
  },
  '#element'
);

document.getElementById('bringLayerForward').onclick = () => {
  /**
   * Move the layer forward
   * Parameter 1 -A string representing the id of the layer to be moved forward.
   */
  diagram.bringLayerForward('layer1');
};

document.getElementById('sendLayerBackward').onclick = () => {
  /**
   * Move the layer Backward
   * Parameter 1 - A string representing the id of the layer to be  moved backward.
   */
  diagram.sendLayerBackward('layer1');
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input
        type="button"
        value="bringLayerForward"
        id="bringLayerForward"
      />
      <input
      type="button"
      value="sendLayerBackward"
      id="sendLayerBackward"
    />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Layer and objects rendering order

The rendering of diagram elements with layer properties involves grouping them within a diagram_diagramLayer for basic shape nodes and diagram_nativeLayer_svg for SVG-native elements. Even if different types of nodes are added within the same layer, the rendering at the DOM level occurs in separate layers. Therefore, when executing layering commands like bringLayerForward and sendLayerBackward, the native SVG elements will always render above the basic shape elements.

The order of rendering is as follows: HTML shapes -> SVG shapes -> Path data shapes & Basic shapes.

Clone Layer

Layers can be cloned with its object by using the cloneLayer public method.

The following code illustrates how to clone the layer.

// A node is created and stored in nodes array.
var nodes = [
  // Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 130,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 160,
    offsetY: 360,
    annotations: [{ content: 'Layer 2 Object' }],
  },
];
// initialize diagram component
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: nodes,
    layers: [
        {
            id: 'layer1',
            //Layer 1 objects
            objects: ['node1', 'node2'],
          },
          {
            id: 'layer2',
            //Layer 2 objects
            objects: ['node3'],
          },
    ],
  },
  '#element'
);

document.getElementById('cloneLayer').onclick = () => {
   /**
   * To Clone the layer
   * Parameter 1 - A string representing the name of the layer to be cloned.
   */
    diagram.cloneLayer('layer1');
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" value="cloneLayer" id="cloneLayer" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Active layer

Active Layer refers to the layer with the highest z-index in a diagram compared to other layers. When adding objects at runtime, they are stored in this active layer. If no layers are explicitly defined in the diagram, a default layer is created and automatically set as the active layer. However, when multiple layers are defined, the layer with the highest z-index takes precedence as the active layer.

Public methods are available to get and set the active layer, which are explained below.

Get ActiveLayer

Active layer of the diagram can be retrieved by using the getActiveLayer public method.

The following code illustrates how fetch active layer from the diagram

// gets the active layer of diagram
let activeLayer = diagram.getActiveLayer();

Set ActiveLayer

You can set any layer to be the active layer of the diagram by using the setActiveLayer public method.

The following code illustrates how to set active layer for diagram

// set the active layer
//@param layerName defines the name of the layer which is to be active layer
diagram.setActiveLayer('layer2');

Layers in Vue Diagram component

Layer organizes related shapes within a Vue Diagram control as named categories. Assigning shapes to different layers enables selective viewing, removal, and locking of distinct shape categories.

In a diagram, Layers facilitate the modification of properties for all shapes assigned to a specific layer. Key properties that can be configured include:

  • Objects
  • Visible
  • Lock
  • AddInfo

Objects

The layer’s objects property specifies which diagram elements belong to that layer. This property contains a collection where you can define the categories of nodes and connectors that the layer encompasses.

In the following example, the basic shapes are categorized in layer 1, and the flow shapes are categorized in layer 2.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :layers='layers'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { DiagramComponent as EjsDiagram,} from '@syncfusion/ej2-vue-diagrams';

const diagram = ref(null);
const nodes = [
  // Layer 1 Nodes
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    shape: { type: "Basic", shape: "Rectangle" },
    annotations: [{ content: "Basic rectangle" }],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 250,
    offsetY: 100,
    shape: { type: "Basic", shape: "Ellipse" },
    annotations: [{ content: "Basic Ellipse" }],
  },
  {
    id: "node3",
    width: 100,
    height: 100,
    offsetX: 400,
    offsetY: 100,
    shape: { type: "Basic", shape: "RightTriangle" },
    annotations: [{ content: "Basic RightTriangle" }],
  },
  {
    id: "node4",
    width: 100,
    height: 100,
    offsetX: 550,
    offsetY: 100,
    shape: { type: "Basic", shape: "Plus" },
    annotations: [{ content: "Basic Plus" }],
  },
  // Layer 2 Nodes
  {
    id: "node5",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    shape: { type: "Flow", shape: "Terminator" },
    annotations: [{ content: "Flow Terminator" }],
  },
  {
    id: "node6",
    width: 100,
    height: 100,
    offsetX: 250,
    offsetY: 300,
    shape: { type: "Flow", shape: "Process" },
    annotations: [{ content: "Flow Process" }],
  },
  {
    id: "node7",
    width: 100,
    height: 100,
    offsetX: 400,
    offsetY: 300,
    shape: { type: "Flow", shape: "Decision" },
    annotations: [{ content: "Flow Decision" }],
  },
  {
    id: "node8",
    width: 100,
    height: 100,
    offsetX: 550,
    offsetY: 300,
    shape: { type: "Flow", shape: "Document" },
    annotations: [{ content: "Flow Document" }],
  },
];


const width = "100%";
const height = "350px";
const layers =[{
          id: "layer1",
          //Layer 1 objects
          objects: ["node1", "node2", "node3", "node4"],
        },
        {
          id: "layer2",
          //Layer 2 objects
          objects: ["node5", "node6", "node7", "node8"],
        },
]

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :layers="layers"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  // Layer 1 Nodes
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    shape: { type: "Basic", shape: "Rectangle" },
    annotations: [{ content: "Basic rectangle" }],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 250,
    offsetY: 100,
    shape: { type: "Basic", shape: "Ellipse" },
    annotations: [{ content: "Basic Ellipse" }],
  },
  {
    id: "node3",
    width: 100,
    height: 100,
    offsetX: 400,
    offsetY: 100,
    shape: { type: "Basic", shape: "RightTriangle" },
    annotations: [{ content: "Basic RightTriangle" }],
  },
  {
    id: "node4",
    width: 100,
    height: 100,
    offsetX: 550,
    offsetY: 100,
    shape: { type: "Basic", shape: "Plus" },
    annotations: [{ content: "Basic Plus" }],
  },
  // Layer 2 Nodes
  {
    id: "node5",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    shape: { type: "Flow", shape: "Terminator" },
    annotations: [{ content: "Flow Terminator" }],
  },
  {
    id: "node6",
    width: 100,
    height: 100,
    offsetX: 250,
    offsetY: 300,
    shape: { type: "Flow", shape: "Process" },
    annotations: [{ content: "Flow Process" }],
  },
  {
    id: "node7",
    width: 100,
    height: 100,
    offsetX: 400,
    offsetY: 300,
    shape: { type: "Flow", shape: "Decision" },
    annotations: [{ content: "Flow Decision" }],
  },
  {
    id: "node8",
    width: 100,
    height: 100,
    offsetX: 550,
    offsetY: 300,
    shape: { type: "Flow", shape: "Document" },
    annotations: [{ content: "Flow Document" }],
  },
];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      layers: [
        {
          id: "layer1",
          //Layer 1 objects
          objects: ["node1", "node2", "node3", "node4"],
        },
        {
          id: "layer2",
          //Layer 2 objects
          objects: ["node5", "node6", "node7", "node8"],
        },
      ],
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Visible

The layer’s visible property is used to control the visibility of the elements assigned to the layer. You can hide objects in one layer while showing objects in another layer.

In the following example, the visibility of layer one is set to false. By default, the visible property of a layer is set to true.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors' :layers='layers'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { DiagramComponent as EjsDiagram,} from '@syncfusion/ej2-vue-diagrams';

const diagram = ref(null);
const nodes = [
  {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      annotations: [{ content: 'Layer 2 Object' }],
    },
];

const connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
];

const width = "100%";
const height = "450px";
const layers =[
       {
          id: 'layer1',
          //Layer 1 visibility set as false.
          visible: false,
          objects: ['node1'],
        },
        {
          id: 'layer2',
          visible: true,
          objects: ['node2', 'connector1'],
        },
]

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :layers="layers"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

let nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      annotations: [{ content: 'Layer 2 Object' }],
    },
];
let connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "450px",
      nodes: nodes,
      connectors: connectors,
      layers: [
       {
          id: 'layer1',
          //Layer 1 visibility set as false.
          visible: false,
          objects: ['node1'],
        },
        {
          id: 'layer2',
          visible: true,
          objects: ['node2', 'connector1'],
        },
      ],
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Lock

The layer’s lock property is used to prevent or allow changes to the element’s dimensions and positions. Locking a layer prevents any interactions with the objects in that layer, such as selecting, dragging, rotating, and connecting.

In the following example the objects in layer one is locked. By default, the lock property of a layer is set to false.

<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :layers="layers"
    ></ejs-diagram>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { DiagramComponent as EjsDiagram } from "@syncfusion/ej2-vue-diagrams";

const diagram = ref(null);
const nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [
        {
          content: 'Layer 1 object Locked',
        },
      ],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      annotations: [
        {
          content: 'Layer 2 Object',
        },
      ],
    },
];

const connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [
        {
          content: 'Layer 2 Object',
        },
      ],
    },
  ];

const width = "100%";
const height = "450px";
const layers = [
  {
    id: "layer1",
    visible: true,
    objects: ["node1"],
    //Locks the layer1 and prevents any interactions to the objects in layer1
    lock: true,
  },
  {
    id: "layer2",
    visible: true,
    objects: ["node2", "connector1"],
    lock: false,
  },
];
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :layers="layers"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";

let nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [
        {
          content: 'Layer 1 object Locked',
        },
      ],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      annotations: [
        {
          content: 'Layer 2 Object',
        },
      ],
    },
];

var connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [
        {
          content: 'Layer 2 Object',
        },
      ],
    },
  ];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "450px",
      nodes: nodes,
      connectors: connectors,
      layers: [
       {
          id: 'layer1',
          visible: true,
          objects: ['node1'],
          //Locks the layer1 and prevents any interactions to the objects in layer1
          lock: true,
        },
        {
          id: 'layer2',
          visible: true,
          objects: ['node2', 'connector1'],
          lock: false,
        },
      ],
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

AddInfo

The addInfo property of layers allow you to maintain additional information to the layers.

The following code illustrates how to add additional information to the layers.

let nodes = [{
    id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
    }
];
let connectors: ConnectorModel[] = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 300
    },
    targetPoint: {
        x: 200,
        y: 400
    },
}];
let addInfo: Object = { Description: 'Layer1' };
export default {
    name: 'app'
    data() {
    return {
        width: "100%",
        height: "350px",
        nodes: nodes,
        layers: [{
            id: 'layer1',
            visible: true,
            objects: ['node1', 'node2', 'connector1'],
            addInfo: addInfo
        }]
    }
}}

Add layer at runtime

Layers can be added at runtime using the addLayer public method.

The layer’s id property defines the ID of the layer, which is used to find the layer at runtime and apply any customizations. You can also add new objects to the new layer using the addLayer method.

The following code illustrates how to add a new layer with new connectors stored in an object array of the new layer:

<template>
    <div id="app">
      <ejs-button v-on:click='addLayer'>Add layer</ejs-button>
      <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :layers='layers'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide, ref,onMounted } from "vue";
import { DiagramComponent as EjsDiagram,} from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
const diagram = ref(null);
const nodes = [
  // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
  
    // Layer 2 Nodes
  
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      annotations: [{ content: 'Layer 2 Object' }],
    },
];


const width = "100%";
const height = "350px";

onMounted(function () {
    diagramInstance = diagram.value.ej2Instances;
});

const layers =[
        {
          id: 'layer1',
          //Layer 1 objects
          objects: ['node1'],
        },
        {
          id: 'layer2',
          //Layer 2 objects
          objects: ['node2'],
        },
];

const addLayer = function() {
    let newLayer = {
      id: 'newlayer',
      visible: true,
      lock: false,
    };
    let layerObject = [
      {
        id: 'con1',
        type: 'Straight',
        sourceID: 'node1',
        targetID: 'node2',
      },
    ];
    /**
     * Add the layers to the existing diagram layer collection
     * newLayer - representing the layer to be added to the diagram.
     * layerObject -  An optional array of objects associated with the layer.
     */
    diagramInstance.addLayer(newLayer, layerObject);
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
<ejs-button v-on:click='addLayer'>Add layer</ejs-button>
  <ejs-diagram
    id="diagram"
    ref="diagram"
    :width="width"
    :height="height"
    :nodes="nodes"
    :layers="layers"
  ></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
let nodes = [
    // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
  
    // Layer 2 Nodes
  
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      annotations: [{ content: 'Layer 2 Object' }],
    },
];


export default {
name: "App",
components: {
  "ejs-diagram": DiagramComponent,
  "ejs-button": ButtonComponent
},
data() {
  return {
    width: "100%",
    height: "450px",
    nodes: nodes,
    layers: [
        {
          id: 'layer1',
          //Layer 1 objects
          objects: ['node1'],
        },
        {
          id: 'layer2',
          //Layer 2 objects
          objects: ['node2'],
        },
    ],
  };
},
mounted: function () {
   diagramInstance = this.$refs.diagram.ej2Instances;
},
methods: {
  addLayer() {
    let newLayer = {
      id: 'newlayer',
      visible: true,
      lock: false,
    };
    let layerObject = [
      {
        id: 'con1',
        type: 'Straight',
        sourceID: 'node1',
        targetID: 'node2',
      },
    ];
    /**
     * Add the layers to the existing diagram layer collection
     * newLayer - representing the layer to be added to the diagram.
     * layerObject -  An optional array of objects associated with the layer.
     */
    diagramInstance.addLayer(newLayer, layerObject);
  }
}
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Remove layer at runtime

Layers can be removed at runtime by using the removeLayer public method.

To remove a layer, pass the ID of the layer you want to remove as a parameter to the removeLayer method.

The following code illustrates how to remove a layer.

<template>
    <div id="app">
      <ejs-button v-on:click='removeLayer'>Remove layer</ejs-button>
      <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :layers='layers'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide, ref, onMounted } from "vue";
import { DiagramComponent as EjsDiagram,} from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
const diagram = ref(null);
const nodes = [
  // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      annotations: [{ content: 'Layer 1 Object' }],
    },
  
    // Layer 2 Nodes
  
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      annotations: [{ content: 'Layer 2 Object' }],
    },
];


const width = "100%";
const height = "350px";

onMounted(function () {
    diagramInstance = diagram.value.ej2Instances;
});

const layers =[
        {
          id: 'layer1',
          //Layer 1 objects
          objects: ['node1'],
        },
        {
          id: 'layer2',
          //Layer 2 objects
          objects: ['node2'],
        },
];
const removeLayer = function() {
     var layerId = 'layer1';
      /**
       * Remove the layer from the existing diagram layer collection
       * layerId - representing the id of the layer to be removed from the diagram.
       */
      diagramInstance.removeLayer(layerId);
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
  <ejs-button v-on:click='removeLayer'>Remove Layer</ejs-button>
  <ejs-diagram
    id="diagram"
    ref="diagram"
    :width="width"
    :height="height"
    :nodes="nodes"
    :layers="layers"
  ></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
let nodes = [
// Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    annotations: [{ content: 'Layer 2 Object' }],
  },
];

export default {
name: "App",
components: {
  "ejs-diagram": DiagramComponent,
  "ejs-button": ButtonComponent
},
data() {
  return {
    width: "100%",
    height: "350px",
    nodes: nodes,
    layers: [
       {
        id: 'layer1',
        //Layer 1 objects
        objects: ['node1'],
      },
      {
        id: 'layer2',
        //Layer 2 objects
        objects: ['node2'],
      },
    ],
  };
},
mounted: function () {
   diagramInstance = this.$refs.diagram.ej2Instances;
},
methods: {
  removeLayer: function() {
    var layerId = 'layer1';
    /**
     * Remove the layer from the existing diagram layer collection
     * layerId - representing the id of the layer to be removed from the diagram.
     */
    diagramInstance.removeLayer(layerId);
  }
}
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

moveObjects

You can move objects from one layer to another dynamically using the moveObjects public method of the diagram control. This can be useful for managing complex diagrams with multiple layers where you need to update the categorization of elements based on user interaction or other dynamic conditions..

The following code illustrates how to move objects from one layer to another layer.

<template>
    <div id="app">
      <ejs-button v-on:click='moveObjects'>Move Objects</ejs-button>
      <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :layers='layers'></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted,provide, ref } from "vue";
import { DiagramComponent as EjsDiagram,} from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
const diagram = ref(null);
const nodes = [
// Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 300,
    annotations: [{ content: 'Layer 2 Object' }],
  },
];


const width = "100%";
const height = "600px";

onMounted(function () {
    diagramInstance = diagram.value.ej2Instances;
});

const layers =[
       {
        id: 'layer1',
        //Layer 1 objects
        objects: ['node1', 'node2'],
      },
      {
        id: 'layer2',
        //Layer 2 objects
        objects: ['node3'],
      },
];
const moveObjects = function() {
    /**
     * Move objects from one layer to another layern
     * Parameter 1 - An array of object IDs represented as strings to be moved
     * parameter 2 -  The ID of the target layer to which the objects should be moved.
     */
    diagramInstance.moveObjects(['node1'], 'layer2');
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
  <ejs-button v-on:click='moveObjects'>Move Objects</ejs-button>
  <ejs-diagram
    id="diagram"
    ref="diagram"
    :width="width"
    :height="height"
    :nodes="nodes"
    :layers="layers"
  ></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
let nodes = [
  // Layer 1 Nodes
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 300,
    annotations: [{ content: 'Layer 1 Object' }],
  },

  // Layer 2 Nodes

  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 300,
    annotations: [{ content: 'Layer 2 Object' }],
  },
];

export default {
name: "App",
components: {
  "ejs-diagram": DiagramComponent,
  "ejs-button": ButtonComponent
},
data() {
  return {
    width: "100%",
    height: "600px",
    nodes: nodes,
    layers: [
      {
        id: 'layer1',
        //Layer 1 objects
        objects: ['node1', 'node2'],
      },
      {
        id: 'layer2',
        //Layer 2 objects
        objects: ['node3'],
      },
    ],
  };
},
mounted: function () {
   diagramInstance = this.$refs.diagram.ej2Instances;
},
methods: {
  moveObjects: function() {
    /**
     * Move objects from one layer to another layern
     * Parameter 1 - An array of object IDs represented as strings to be moved
     * parameter 2 -  The ID of the target layer to which the objects should be moved.
     */
    diagramInstance.moveObjects(['node1'], 'layer2');
  }
}
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Z-Index

zIndex property of a layer defines its Z order within the diagram. This property allows you to control the layer’s position in the stacking order. You can adjust the layer’s z-index by moving it forward or backward relative to other layers in the diagram.

Bring Layer Forward

Layers can be moved forward at runtime by using the bringLayerForward public method.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
        }
    }
    mounted: function() {
        let diagramInstance: Diagram;
        let diagramObj: any = document.getElementById("diagram");
        diagramInstance = diagramObj.ej2_instances[0];
        // move the layer forward
        diagram.bringLayerForward('layer1');
    }
}

Send Layer Backward

Layers can be moved backward at runtime by using the sendLayerBackward public method.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
        }
    }
    mounted: function() {
        let diagramInstance: Diagram;
        let diagramObj: any = document.getElementById("diagram");
        diagramInstance = diagramObj.ej2_instances[0];
        // move the layer backward
        diagram.sendLayerBackward('layer1');
    }
}

The following code illustrates how to send the layer forward/backward to another layer.

<template>
    <div id="app">
      <ejs-button v-on:click='bringLayerForward'>Bring Layer Forward</ejs-button>
      <ejs-button v-on:click='sendLayerBackward'>Send Layer Backward</ejs-button>
      <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :layers='layers'></ejs-diagram>
    </div>
</template>
<script setup>
import { onMounted,provide, ref } from "vue";
import { DiagramComponent as EjsDiagram,} from '@syncfusion/ej2-vue-diagrams';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
const diagram = ref(null);
const nodes = [
{
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },
  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 130,
    offsetY: 130,
    annotations: [{ content: 'Layer 2 Object' }],
  },
  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 160,
    offsetY: 160,
    annotations: [{ content: 'Layer 3 Object' }],
  },
];

const width = "100%";
const height = "600px";

onMounted(function () {
    diagramInstance = diagram.value.ej2Instances;
});

const layers =[
      {
        id: 'layer1',
        objects: ['node1'],
      },
      {
        id: 'layer2',
        objects: ['node2'],
      },
      {
        id: 'layer3',
        objects: ['node3'],
      },
];
const bringLayerForward = function() {
    /**
     * Move the layer forward
     * Parameter 1 -A string representing the id of the layer to be moved forward.
     */
    diagramInstance.bringLayerForward('layer1');
}

const sendLayerBackward = function() {
    /**
     * Move the layer Backward
     * Parameter 1 - A string representing the id of the layer to be  moved backward.
     */
    diagramInstance.sendLayerBackward('layer1');
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app">
  <ejs-button v-on:click='bringLayerForward'>Bring Layer Forward</ejs-button>
  <ejs-button v-on:click='sendLayerBackward'>Send Layer Backward</ejs-button>
  <ejs-diagram
    id="diagram"
    ref="diagram"
    :width="width"
    :height="height"
    :nodes="nodes"
    :layers="layers"
  ></ejs-diagram>
</div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

let diagramInstance;
let nodes = [
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Layer 1 Object' }],
  },
  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 130,
    offsetY: 130,
    annotations: [{ content: 'Layer 2 Object' }],
  },
  {
    id: 'node3',
    width: 100,
    height: 100,
    offsetX: 160,
    offsetY: 160,
    annotations: [{ content: 'Layer 3 Object' }],
  },
];

export default {
name: "App",
components: {
  "ejs-diagram": DiagramComponent,
  "ejs-button": ButtonComponent
},
data() {
  return {
    width: "100%",
    height: "600px",
    nodes: nodes,
    layers: [
      {
        id: 'layer1',
        objects: ['node1'],
      },
      {
        id: 'layer2',
        objects: ['node2'],
      },
      {
        id: 'layer3',
        objects: ['node3'],
      },
    ],
  };
},
mounted: function () {
   diagramInstance = this.$refs.diagram.ej2Instances;
},
methods: {
  bringLayerForward: function() {
    /**
     * Move the layer forward
     * Parameter 1 -A string representing the id of the layer to be moved forward.
     */
    diagramInstance.bringLayerForward('layer1');
  },
  sendLayerBackward: function() {
    /**
     * Move the layer Backward
     * Parameter 1 - A string representing the id of the layer to be  moved backward.
     */
    diagramInstance.sendLayerBackward('layer1');
  },

}
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Layer and objects rendering order

The rendering of diagram elements with layer properties involves grouping them within a diagram_diagramLayer for basic shape nodes and diagram_nativeLayer_svg for SVG-native elements. Even if different types of nodes are added within the same layer, the rendering at the DOM level occurs in separate layers. Therefore, when executing layering commands like bringLayerForward and sendLayerBackward, the native SVG elements will always render above the basic shape elements.

The order of rendering is as follows: HTML shapes -> SVG shapes -> Path data shapes & Basic shapes.

Clone Layer

Layers can be cloned with its object by using the cloneLayer public method.

The following code illustrates how to clone the layer.

<template>
  <div id="app">
    <ejs-button v-on:click="cloneLayer">Clone Layer</ejs-button>
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :layers="layers"
    ></ejs-diagram>
  </div>
</template>
<script setup>
import { onMounted,provide, ref } from "vue";
import { DiagramComponent as EjsDiagram } from "@syncfusion/ej2-vue-diagrams";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";

let diagramInstance;
const diagram = ref(null);
const nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: "Layer 1 Object" }],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 130,
    annotations: [{ content: "Layer 1 Object" }],
  },
  {
    id: "node3",
    width: 100,
    height: 100,
    offsetX: 160,
    offsetY: 360,
    annotations: [{ content: "Layer 2 Object" }],
  },
];

const width = "100%";
const height = "600px";

onMounted(function () {
    diagramInstance = diagram.value.ej2Instances;
});

const layers = [
  {
    id: "layer1",
    objects: ["node1", "node2"],
  },
  {
    id: "layer2",
    objects: ["node3"],
  },
];
const cloneLayer = function () {
      /**
       * To Clone the layer
       * Parameter 1 - A string representing the name of the layer to be cloned.
       */
      diagramInstance.cloneLayer('layer1');
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-button v-on:click="cloneLayer">Clone Layer</ejs-button>
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :layers="layers"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";


let diagramInstance;
let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: "Layer 1 Object" }],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 130,
    annotations: [{ content: "Layer 1 Object" }],
  },
  {
    id: "node3",
    width: 100,
    height: 100,
    offsetX: 160,
    offsetY: 360,
    annotations: [{ content: "Layer 2 Object" }],
  },
];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
    "ejs-button": ButtonComponent,
  },
  data() {
    return {
      width: "100%",
      height: "600px",
      nodes: nodes,
      layers: [
        {
          id: "layer1",
          objects: ["node1", "node2"],
        },
        {
          id: "layer2",
          objects: ["node3"],
        },
      ],
    };
  },
  mounted: function () {
   diagramInstance = this.$refs.diagram.ej2Instances;
},
  methods: {
    cloneLayer: function () {
      /**
       * To Clone the layer
       * Parameter 1 - A string representing the name of the layer to be cloned.
       */
      diagramInstance.cloneLayer('layer1');
    }
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Active layer

Active Layer refers to the layer with the highest z-index in a diagram compared to other layers. When adding objects at runtime, they are stored in this active layer. If no layers are explicitly defined in the diagram, a default layer is created and automatically set as the active layer. However, when multiple layers are defined, the layer with the highest z-index takes precedence as the active layer.

Public methods are available to get and set the active layer, which are explained below.

Get ActiveLayer

Active layer of the diagram can be retrieved by using the getActiveLayer public method.

The following code illustrates how fetch active layer from the diagram

let activeLayer = diagramInstance.getActiveLayer();

Set ActiveLayer

You can set any layer to be the active layer of the diagram by using the setActiveLayer public method.

The following code illustrates how to set active layer for diagram

diagramInstance.setActiveLayer('layer2');

Layers in Angular Diagram Component

Layers provide a powerful organizational system for managing diagram elements by grouping related shapes into named categories. This functionality enables developers to build complex diagrams with selective viewing, interaction control, and bulk property management across multiple elements simultaneously.

Core Layer Properties

In a diagram, Layers enable modification of properties for all shapes assigned to a specific layer. The primary configurable properties include:

  • Objects - Define which elements belong to the layer
  • Visible - Control layer visibility
  • Lock - Prevent interactions with layer elements
  • AddInfo - Store additional custom information

Objects

The layer’s objects property specifies which diagram elements belong to that layer. This property contains a collection of element IDs that defines the categories of nodes and connectors the layer encompasses.

Use case: Separate different types of diagram elements for independent management - for example, keeping background elements in one layer and interactive elements in another.

In the following example, basic shapes are categorized in layer 1, and flow shapes are categorized in layer 2:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule,DiagramComponent,LayerModel,BasicShapeModel,FlowShapeModel } from '@syncfusion/ej2-angular-diagrams';


@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 [shape]='shape1' >
                <e-node-annotations>
                    <e-node-annotation content="Basic Rectangle">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=250 [offsetY]=100 [shape]='shape2'>
                <e-node-annotations>
                    <e-node-annotation content="Basic Ellipse">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node3' [width]=100 [height]=100 [offsetX]=400 [offsetY]=100 [shape]='shape3' >
                <e-node-annotations>
                    <e-node-annotation content="Basic RightTriangle">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node4' [width]=100 [height]=100 [offsetX]=550 [offsetY]=100 [shape]='shape4' >
                <e-node-annotations>
                    <e-node-annotation content="Basic Plus">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node5' [width]=100 [height]=100 [offsetX]=100 [offsetY]=300 [shape]='shape5' >
                <e-node-annotations>
                    <e-node-annotation content="Flow Terminator">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node6' [width]=100 [height]=100 [offsetX]=250 [offsetY]=300 [shape]='shape6' >
                <e-node-annotations>
                    <e-node-annotation content="Flow Process">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node7' [width]=100 [height]=100 [offsetX]=400 [offsetY]=300 [shape]='shape7' >
                <e-node-annotations>
                    <e-node-annotation content="Flow Decision">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node8' [width]=100 [height]=100 [offsetX]=550 [offsetY]=300 [shape]='shape8' >
                <e-node-annotations>
                    <e-node-annotation content="Flow Document">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node> 
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];

    ngOnInit(): void {
        this.layers = [
            {
                id: 'layer1',
                visible: true,
                //Layer 1 objects
                objects: ['node1','node2','node3','node4'],
                lock: false
            },
            {
                id: 'layer2',
                visible: true,
                //Layer 2 objects
                objects: ['node5','node6','node7','node8'],
                lock: false
            }
        ]
    }
    public shape1: BasicShapeModel = {
        type: 'Basic',
        shape: 'Rectangle',
    };
    public shape2: BasicShapeModel = {
        type: 'Basic',
        shape: 'Ellipse',
    };
    public shape3: BasicShapeModel = {
        type: 'Basic',
        shape: 'RightTriangle',
    };
    public shape4: BasicShapeModel = {
        type: 'Basic',
        shape: 'Plus',
    };
    public shape5: FlowShapeModel = {
        type: 'Flow',
        shape: 'Terminator',
    };
    public shape6: FlowShapeModel = {
        type: 'Flow',
        shape: 'Process',
    };
    public shape7: FlowShapeModel = {
        type: 'Flow',
        shape: 'Decision',
    };
    public shape8: FlowShapeModel = {
        type: 'Flow',
        shape: 'Document',
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Visible

The layer’s visible property controls the visibility of all elements assigned to the layer. This allows selective display of different diagram sections without removing elements permanently.

Use case: Create diagrams with multiple views where users can toggle between different information layers, such as showing only critical path items in a project diagram.

In the following example, the visibility of layer one is set to false. By default, the visible property of a layer is set to true:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule,DiagramComponent,PointModel,LayerModel} from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=300 [offsetY]=100>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-connectors>
                <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint'>
                <e-connector-annotations>
                    <e-connector-annotation content="Layer 2 object">
                    </e-connector-annotation>
                </e-connector-annotations>
                </e-connector>
            </e-connectors>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];
    public sourcePoint?: PointModel;
    public targetPoint?: PointModel;

    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 300 };
        this.targetPoint = { x: 200, y: 400 };
        this.layers = [
            {
                id: 'layer1',
                //Layer 1 visibility set as false.
                visible: false,
                objects: ['node1']
            },
            {
                id: 'layer2',
                //Layer 1 visibility set as true.
                visible: true,
                objects: ['node2', 'connector'],
            },
        ]
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Lock

The layer’s lock property prevents or allows changes to element dimensions and positions. When a layer is locked, all interactions with objects in that layer are disabled, including selecting, dragging, rotating, and connecting operations.

Use case: Protect template elements or background graphics from accidental modification while allowing users to work with other diagram elements.

In the following example, the objects in layer one are locked. By default, the lock property of a layer is set to false:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule,DiagramComponent,PointModel,LayerModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 object locked">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=300 [offsetY]=100>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-connectors>
                <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint'>
                <e-connector-annotations>
                    <e-connector-annotation content="Layer 2 object">
                    </e-connector-annotation>
                </e-connector-annotations>
                </e-connector>
            </e-connectors>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];
    public sourcePoint?: PointModel;
    public targetPoint?: PointModel;

    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 300 };
        this.targetPoint = { x: 200, y: 400 };
        this.layers = [
            {
                id: 'layer1',
                visible: true,
                objects: ['node1'],
                //Locks the layer1 and prevents any interactions to the objects in layer1
                lock: true,
            },
            {
                id: 'layer2',
                visible: true,
                objects: ['node2', 'connector'],
                lock: false
            },
        ]
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

AddInfo

The addInfo property allows storage of additional custom information with layers. This can be useful for storing metadata, configuration settings, or application-specific data associated with the layer.

Use case: Store layer descriptions, creation timestamps, owner information, or custom application data for enhanced layer management.

The following code illustrates how to add additional information to layers:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, PointModel, LayerModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-connectors>
            <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint'>
            </e-connector>
    </e-connectors>
    <e-nodes>
            <e-node id='node1' [offsetX]=150 [offsetY]=150></e-node>
            <e-node id='node2' [offsetX]=350 [offsetY]=350></e-node>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram: DiagramComponent;
    public sourcePoint: PointModel;
    public targetPoint: PointModel;
    public layers: LayerModel[];
    public addInfo: Object = { Description: 'Layer1' };
    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
        this.layers = [{
            id: 'layer1',
            visible: true,
            objects: ['node1', 'connector'],
            lock: true,
            addInfo: this.addInfo

        },
        {
            id: 'layer2',
            visible: true,
            objects: ['node2'],
            lock: false
        }];
    }
}

Add Layer at Runtime

Layers can be added at runtime by using the addLayer public method.

The layer’s ID property defines the ID of the layer, which is used to find the layer at runtime and apply any customizations. You can also add new objects to the new layer using the addLayer method.

The following code illustrates how to add a layer.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent,LayerModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <button (click)="addLayer()">addLayer</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=100 [offsetY]=300>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];
    ngOnInit(): void {
        this.layers = [
            {
                id: 'layer1',
                objects: ['node1']
            },
            {
                id: 'layers2',
                objects:['node2']
            }
        ]
    }

    /**
     * Add the layers to the existing diagram layer collection
     * newLayer - representing the layer to be added to the diagram.
     * layerObject -  An optional array of objects associated with the layer.
     */
    addLayer() {
        (this.diagram as any).addLayer({
            id: 'newlayer',
            visible: true,
            lock: false,
        }, [{
            type: 'Straight',
            sourceID: 'node1',
            targetID: 'node2',
            
        }]);
    }
   
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Remove Layer at Runtime

Layers can be removed at runtime by using the removeLayer public method.

To remove a layer, pass the ID of the layer you want to remove as a parameter to the removeLayer method.

The following code illustrates how to remove a layer.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent,LayerModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <button (click)="removeLayer()">removeLayer</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=100 [offsetY]=300>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];

    ngOnInit(): void {
        this.layers = [
            {
                id: 'layer1',
                objects: ['node1']
            },
            {
                id: 'layer2',
                objects:['node2']
            },
        ]
    }

    /**
     * Remove the layer from the existing diagram layer collection
     * layerId - representing the id of the layer to be removed from the diagram.
     */
     removeLayer() {
        (this.diagram as any).removeLayer('layer1');
    }
    
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

MoveObjects

You can move objects from one layer to another dynamically using the moveObjects public method of the diagram control. This can be useful for managing complex diagrams with multiple layers where you need to update the categorization of elements based on user interaction or other dynamic conditions.

The following code illustrates how to move objects from one layer to another layer from the diagram.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule,DiagramComponent, LayerModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <button (click)="moveObjects()">moveObjects</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=100 [offsetY]=300>
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node3' [width]=100 [height]=100 [offsetX]=300 [offsetY]=300>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];

    ngOnInit(): void {
        this.layers = [
            {
                id: 'layer1',
                objects: ['node1','node2']
            },
            {
                id: 'layers2',
                objects:['node3']
            },
        ]
    }

    /**
     * Move objects from one layer to another layer
     * Parameter 1 - An array of object IDs represented as strings to be moved
     * parameter 2 -  The ID of the target layer to which the objects should be moved.
     */
     moveObjects() {
        (this.diagram as any).moveObjects(['node1'], 'layer2');
        console.log(this.layers);
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Z-Index and Layer Ordering

The zIndex property of a layer defines its position in the stacking order within the diagram. Higher z-index values render above lower values, allowing control over which layers appear in front of others.

Bring layer forward

Move a layer forward in the stacking order using the bringLayerForward public method:

// Move the specified layer forward in the stacking order
this.diagram.bringLayerForward('layer1');

Send Layer Backward

Move a layer backward in the stacking order using the sendLayerBackward public method:

// Move the specified layer backward in the stacking order
this.diagram.sendLayerBackward('layer1');

The following code illustrates how to send the layer forward/backward to another layer.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramComponent, LayerModel } from '@syncfusion/ej2-angular-diagrams';

@Component({
imports: [
             DiagramModule
    ],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <button (click)="bringLayerForward()">bringLayerForward</button>
    <button (click)="sendLayerBackward()">sendLayerBackward</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=130 [offsetY]=130>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node3' [width]=100 [height]=100 [offsetX]=160 [offsetY]=160>
                <e-node-annotations>
                    <e-node-annotation content="Layer 3 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];
    ngOnInit(): void {
        this.layers = [
            {
                id: 'layer1',
                objects: ['node1']
            },
            {
                id: 'layers2',
                objects:['node2']
            },
            {
                id: 'layers3',
                objects:['node3']
            }
        ]
    }

    /**
     * Move the layer forward
     * Parameter 1 -A string representing the id of the layer to be moved forward.
     */
    bringLayerForward() {
        (this.diagram as any).bringLayerForward('layer1');
    }

    /**
     * Move the layer Backward
     * Parameter 1 - A string representing the id of the layer to be  moved backward.
     */
    sendLayerBackward() {
        (this.diagram as any).sendLayerBackward('layer1');
    }
    
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Layer and objects rendering order

The rendering of diagram elements with layer properties involves grouping them within a diagram_diagramLayer for basic shape nodes and diagram_nativeLayer_svg for SVG-native elements. Even if different types of nodes are added within the same layer, the rendering at the DOM level occurs in separate layers. Therefore, when executing layering commands like bringLayerForward and sendLayerBackward, the native SVG elements will always render above the basic shape elements.

The order of rendering is as follows: HTML shapes -> SVG shapes -> Path data shapes & Basic shapes.

Clone Layer

Layers can be cloned along with their objects using the cloneLayer public method. This creates an identical copy of the layer and all its assigned elements.

Use case: Create template layers or duplicate complex layer configurations for reuse in different diagram sections.

The following code illustrates how to clone a layer:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule , LayerModel, DiagramComponent } from '@syncfusion/ej2-angular-diagrams'

@Component({
imports: [
             DiagramModule
],
providers: [ ],
standalone: true,
    selector: "app-container",
    template: `
    <button (click)="clonelayer()">clonelayer</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="580px" [layers]="layers">
    <e-nodes>
            <e-node id='node1' [width]=100 [height]=100 [offsetX]=100 [offsetY]=100 >
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [width]=100 [height]=100 [offsetX]=160 [offsetY]=360>
                <e-node-annotations>
                    <e-node-annotation content="Layer 2 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node3' [width]=100 [height]=100 [offsetX]=300 [offsetY]=100>
                <e-node-annotations>
                    <e-node-annotation content="Layer 1 Object">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
    </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public layers: LayerModel[] =[];
    ngOnInit(): void {
        this.layers = [
            {
                id: 'layer1',
                objects: ['node1', 'node3']
            },
            {
                id: 'layers2',
                objects:['node2']
            }
        ]
    
    }
    /**
     * To Clone the layer
     * Parameter 1 - A string representing the name of the  layer to be cloned.
     */
    clonelayer() {
        (this.diagram as any).cloneLayer('layer1');
    }
    
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Active Layer

The active layer represents the layer with the highest z-index in a diagram. When objects are added at runtime, they are automatically assigned to the active layer. If no layers are explicitly defined, a default layer is created and set as the active layer. When multiple layers exist, the layer with the highest z-index becomes the active layer.

Use case: Ensure new elements are added to the appropriate layer in multi-layer diagrams, particularly in interactive editing scenarios.

Get active layer

Retrieve the current active layer of the diagram using the getActiveLayer public method:

// Gets the currently active layer
this.diagram.getActiveLayer();

Set active layer

Set any layer as the active layer using the setActiveLayer public method:

// Set the specified layer as active
// @param layerName defines the name of the layer to be set as active
this.diagram.setActiveLayer('layer2');

Layers in React Diagram Component

Layers provide a powerful organizational system for managing diagram elements by grouping related shapes into named categories. This functionality enables developers to build complex diagrams with selective viewing, interaction control, and bulk property management across multiple elements simultaneously.

Core Layer Properties

In a diagram, Layers enable modification of properties for all shapes assigned to a specific layer. The primary configurable properties include:

  • Objects - Define which elements belong to the layer.
  • Visible - Control layer visibility.
  • Lock - Prevent interactions with layer elements.
  • AddInfo - Store additional custom information.

Objects

The layer’s objects property specifies which diagram elements belong to that layer. This property contains a collection of element IDs that defines the categories of nodes and connectors the layer encompasses.

Use case: Separate different types of diagram elements for independent management - for example, keeping background elements in one layer and interactive elements in another.

In the following example, basic shapes are categorized in layer 1, and flow shapes are categorized in layer 2:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";


let nodes= [
    // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Rectangle' },
      annotations: [{ content: 'Basic rectangle' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 250,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Ellipse' },
      annotations: [{ content: 'Basic Ellipse' }],
    },
    {
      id: 'node3',
      width: 100,
      height: 100,
      offsetX: 400,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'RightTriangle' },
      annotations: [{ content: 'Basic RightTriangle' }],
    },
    {
      id: 'node4',
      width: 100,
      height: 100,
      offsetX: 550,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Plus' },
      annotations: [{ content: 'Basic Plus' }],
    },
  
    // Layer 2 Nodes
    {
      id: 'node5',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Terminator' },
      annotations: [{ content: 'Flow Terminator' }],
    },
    {
      id: 'node6',
      width: 100,
      height: 100,
      offsetX: 250,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Process' },
      annotations: [{ content: 'Flow Process' }],
    },
    {
      id: 'node7',
      width: 100,
      height: 100,
      offsetX: 400,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Decision' },
      annotations: [{ content: 'Flow Decision' }],
    },
    {
      id: 'node8',
      width: 100,
      height: 100,
      offsetX: 550,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Document' },
      annotations: [{ content: 'Flow Document' }],
    },
];

// initialize diagram component
function App() {
return (
<DiagramComponent
  id="container"
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                //Layer 1 objects
                objects: ['node1', 'node2','node3','node4']
            },
            {
                id: 'layer2',
                //Layer 2 objects
                objects: ['node5','node6','node7','node8'],
            }
        ]
    }
/>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";


let nodes: NodeModel[] = [
    // Layer 1 Nodes
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Rectangle' },
      annotations: [{ content: 'Basic rectangle' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 250,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Ellipse' },
      annotations: [{ content: 'Basic Ellipse' }],
    },
    {
      id: 'node3',
      width: 100,
      height: 100,
      offsetX: 400,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'RightTriangle' },
      annotations: [{ content: 'Basic RightTriangle' }],
    },
    {
      id: 'node4',
      width: 100,
      height: 100,
      offsetX: 550,
      offsetY: 100,
      shape: { type: 'Basic', shape: 'Plus' },
      annotations: [{ content: 'Basic Plus' }],
    },
  
    // Layer 2 Nodes
    {
      id: 'node5',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Terminator' },
      annotations: [{ content: 'Flow Terminator' }],
    },
    {
      id: 'node6',
      width: 100,
      height: 100,
      offsetX: 250,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Process' },
      annotations: [{ content: 'Flow Process' }],
    },
    {
      id: 'node7',
      width: 100,
      height: 100,
      offsetX: 400,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Decision' },
      annotations: [{ content: 'Flow Decision' }],
    },
    {
      id: 'node8',
      width: 100,
      height: 100,
      offsetX: 550,
      offsetY: 300,
      shape: { type: 'Flow', shape: 'Document' },
      annotations: [{ content: 'Flow Document' }],
    },
];

// initialize diagram component
function App() {
return (
<DiagramComponent
  id="container"
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                //Layer 1 objects
                objects: ['node1', 'node2','node3','node4']
            },
            {
                id: 'layer2',
                //Layer 2 objects
                objects: ['node5','node6','node7','node8'],
            }
        ]
    }
/>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Visible

The layer’s visible property controls the visibility of all elements assigned to the layer. This allows selective display of different diagram sections without removing elements permanently.

Use case: Create diagrams with multiple views where users can toggle between different information layers, such as showing only critical path items in a project diagram.

In the following example, the visibility of layer one is set to false. By default, the visible property of a layer is set to true:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";


let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
      },
      {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
      },
];
let connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];

// initialize diagram component
function App() {
return (
<DiagramComponent
  id="container"
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  connectors={connectors}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                //Layer 1 visibility set as false.
                visible: false,
                objects: ['node1'],
            },
            {
                id: 'layer2',
                //Layer 1 visibility set as true.
                visible: true,
                objects: ['node2', 'connector1'],
            },
        ]
    }
/>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent,NodeModel,ConnectorModel } from "@syncfusion/ej2-react-diagrams";


let nodes: NodeModel[]= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
      },
      {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
      },
];
let connectors:ConnectorModel[] = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];

// initialize diagram component
function App() {
return (
<DiagramComponent
  id="container"
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  connectors={connectors}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                //Layer 1 visibility set as false.
                visible: false,
                objects: ['node1'],
            },
            {
                id: 'layer2',
                //Layer 1 visibility set as true.
                visible: true,
                objects: ['node2', 'connector1'],
            },
        ]
    }
/>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Lock

The layer’s lock property prevents or allows changes to element dimensions and positions. When a layer is locked, all interactions with objects in that layer are disabled, including selecting, dragging, rotating, and connecting operations.

Use case: Protect template elements or background graphics from accidental modification while allowing users to work with other diagram elements.

In the following example, the objects in layer one are locked. By default, the lock property of a layer is set to false:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";


let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object Locked' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];
let connectors = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];

// initialize diagram component
function App() {
return (
<DiagramComponent
  id="container"
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  connectors={connectors}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                visible: true,
                objects: ['node1'],
                //Locks the layer1 and prevents any interactions to the objects in layer1
                lock: true,
            },
            {
                id: 'layer2',
                visible: true,
                objects: ['node2', 'connector1'],
                lock: false,
            },
        ]
    }
/>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent,NodeModel,ConnectorModel } from "@syncfusion/ej2-react-diagrams";


let nodes: NodeModel[]= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object Locked' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];
let connectors: ConnectorModel[] = [
    {
      id: 'connector1',
      type: 'Straight',
      sourcePoint: {
        x: 100,
        y: 300,
      },
      targetPoint: {
        x: 200,
        y: 400,
      },
      annotations: [{ content: 'Layer 2 Object' }],
    },
  ];

// initialize diagram component
function App() {
return (
<DiagramComponent
  id="container"
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  connectors={connectors}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                visible: true,
                objects: ['node1'],
                //Locks the layer1 and prevents any interactions to the objects in layer1
                lock: true,
            },
            {
                id: 'layer2',
                visible: true,
                objects: ['node2', 'connector1'],
                lock: false,
            },
        ]
    }
/>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

AddInfo

The addInfo property allows storage of additional custom information with layers. This can be useful for storing metadata, configuration settings, or application-specific data associated with the layer.

Use case: Store layer descriptions, creation timestamps, owner information, or custom application data for enhanced layer management.

The following code illustrates how to add additional information to layers:

// A node is created and stored in nodes array.
let nodes: NodeModel[] = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{
            content: 'Default Shape'
        }]
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        shape: {
            type: 'Path',
            data: 'M540.3643,137.9336L546.7973,159.7016L570.3633,159.7296L550.7723,171.9366L558.9053,194.9966L540.3643,' +
                '179.4996L521.8223,194.9966L529.9553,171.9366L510.3633,159.7296L533.9313,159.7016L540.3643,137.9336z'
        },
        annotations: [{
            content: 'Path Element'
        }]
    }
];
let connectors: ConnectorModel[] = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 300
    },
    targetPoint: {
        x: 200,
        y: 400
    },
}];
let addInfo: Object = { Description: 'Layer1' };
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      nodes={nodes}
      connectors={connectors}
      // Add layer
      layers = {
            [
                {
                    id: 'layer1',
                    visible: true,
                    objects: ['node1', 'node2'],
                    addInfo: addInfo
                },
                {
                    id: 'layer2',
                    visible: true,
                    objects: ['node2'],
                }
            ]
        }
      // render initialized Diagram
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Add Layer at Runtime

Layers can be added at runtime using the addLayer public method.

The layer’s ID property defines the ID of the layer, which is used to find the layer at runtime and apply any customizations. You can also add new objects to the new layer using the addLayer method.

The following code illustrates how to add a new layer with new connectors stored in an object array of the new layer:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance;


let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

//method to add layer through run time.
const addLayer = () => {
    /**
   * Add the layers to the existing diagram layer collection
   * newLayer - representing the layer to be added to the diagram.
   * layerObject -  An optional array of objects associated with the layer.
   */
    let newLayer = {
        id: 'newlayer',
        visible: true,
        lock: false,
      };
    let layerObject = [
        {
          id: 'con1',
          type: 'Straight',
          sourceID: 'node1',
          targetID: 'node2',
        },
    ];
    diagramInstance.addLayer(newLayer, layerObject);
  }

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="Add Layer" onClick={addLayer} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1'],
            },
            {
                id: 'layer2',
                objects: ['node2'],
            },
        ]
    }
/>
</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent,NodeModel, } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance: DiagramComponent;


let nodes: NodeModel[]= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

//method to add layer through run time.
const addLayer = () => {
    /**
   * Add the layers to the existing diagram layer collection
   * newLayer - representing the layer to be added to the diagram.
   * layerObject -  An optional array of objects associated with the layer.
   */
    let newLayer = {
        id: 'newlayer',
        visible: true,
        lock: false,
      };
    let layerObject = [
        {
          id: 'con1',
          type: 'Straight',
          sourceID: 'node1',
          targetID: 'node2',
        },
    ];
    diagramInstance.addLayer(newLayer, layerObject);
  }

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="Add Layer" onClick={addLayer} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1'],
            },
            {
                id: 'layer2',
                objects: ['node2'],
            },
        ]
    }
/>

</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Remove Layer at Runtime

Layers can be removed at runtime by using the removeLayer public method.

To remove a layer, pass the ID of the layer you want to remove as a parameter to the removeLayer method.

The following code illustrates how to remove a layer.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance;

let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];


//Method to remove layer through run time
const removeLayer = () => {
    /**
     * Remove the layer from the existing diagram layer collection
     * layerId - representing the id of the layer to be removed from the diagram.
     */
    diagramInstance.removeLayer('layer1');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="Remove Layer" onClick={removeLayer} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1'],
            },
            {
                id: 'layer2',
                objects: ['node2'],
            },
        ]
    }
/>

</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance: DiagramComponent;

let nodes: NodeModel[] = [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

//Method to remove layer through run time
const removeLayer = () => {
    /**
     * Remove the layer from the existing diagram layer collection
     * layerId - representing the id of the layer to be removed from the diagram.
     */
    diagramInstance.removeLayer('layer1');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="Remove Layer" onClick={removeLayer} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1'],
            },
            {
                id: 'layer2',
                objects: ['node2'],
            },
        ]
    }
/>

</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

MoveObjects

You can move objects from one layer to another dynamically using the moveObjects public method of the diagram control. This can be useful for managing complex diagrams with multiple layers where you need to update the categorization of elements based on user interaction or other dynamic conditions.

The following code illustrates how to move objects from one layer to another layer.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance;

let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 300,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

const moveObjects = () => {
    /**
   * Move objects from one layer to another layer
   * Parameter 1 - An array of object IDs represented as strings to be moved
   * parameter 2 -  The ID of the target layer to which the objects should be moved.
   */
    diagramInstance.moveObjects(['node1'], 'layer2');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="Move Objects" onClick={moveObjects} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1','node2'],
            },
            {
                id: 'layer2',
                objects: ['node3'],
            },
        ]
    }
/>
</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance: DiagramComponent;

let nodes: NodeModel[]= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 300,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

const moveObjects = () => {
    /**
   * Move objects from one layer to another layer
   * Parameter 1 - An array of object IDs represented as strings to be moved
   * parameter 2 -  The ID of the target layer to which the objects should be moved.
   */
    diagramInstance.moveObjects(['node1'], 'layer2');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="Move Objects" onClick={moveObjects} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1','node2'],
            },
            {
                id: 'layer2',
                objects: ['node3'],
            },
        ]
    }
/>

</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Z-Index

zIndex property of a layer defines its position in the stacking order within the diagram. Higher z-index values render above lower values, allowing control over which layers appear in front of others.

Bring Layer Forward

Move a layer forward in the stacking order using the bringLayerForward public method.

The following code illustrates how to bring forward to layer.

// move the layer forward
diagram.bringLayerForward('layer1');

Send Layer Backward

Move a layer backward in the stacking order using the sendLayerBackward public method.

// move the layer backward
diagram.sendLayerBackward('layer1');

The following code illustrates how to send the layer forward/backward to another layer.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance;

let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 130,
        offsetY: 130,
        annotations: [{ content: 'Layer 2 Object' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 160,
        offsetY: 160,
        annotations: [{ content: 'Layer 3 Object' }],
    },
];

const bringLayerForward = () => {
    /**
     * Move the layer forward
     * Parameter 1 -A string representing the id of the layer to be moved forward.
     */
    diagramInstance.bringLayerForward('layer1');
}

const sendLayerBackward = () => {
    /**
     * Move the layer Backward
     * Parameter 1 - A string representing the id of the layer to be  moved backward.
     */
    diagramInstance.sendLayerBackward('layer1');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="bringLayerForward" onClick={bringLayerForward} />
<ButtonComponent content="sendLayerBackward" onClick={sendLayerBackward} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1'],
            },
            {
                id: 'layer2',
                objects: ['node2'],
            },
            {
                id: 'layer3',
                objects: ['node3'],
            },
        ]
    }
/>
</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent,NodeModel } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance: DiagramComponent;

let nodes: NodeModel[]= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 130,
        offsetY: 130,
        annotations: [{ content: 'Layer 2 Object' }],
    },
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 160,
        offsetY: 160,
        annotations: [{ content: 'Layer 3 Object' }],
    },
];

const bringLayerForward = () => {
    /**
     * Move the layer forward
     * Parameter 1 -A string representing the id of the layer to be moved forward.
     */
    diagramInstance.bringLayerForward('layer1');
}

const sendLayerBackward = () => {
    /**
     * Move the layer Backward
     * Parameter 1 - A string representing the id of the layer to be  moved backward.
     */
    diagramInstance.sendLayerBackward('layer1');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="bringLayerForward" onClick={bringLayerForward} />
<ButtonComponent content="sendLayerBackward" onClick={sendLayerBackward} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1'],
            },
            {
                id: 'layer2',
                objects: ['node2'],
            },
            {
                id: 'layer3',
                objects: ['node3'],
            },
        ]
    }
/>
</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Layer and Objects Rendering Order

The rendering of diagram elements with layer properties involves grouping them within a diagram_diagramLayer for basic shape nodes and diagram_nativeLayer_svg for SVG-native elements. Even if different types of nodes are added within the same layer, the rendering at the DOM level occurs in separate layers. Therefore, when executing layering commands like bringLayerForward and sendLayerBackward, the native SVG elements will always render above the basic shape elements.

The order of rendering is as follows: HTML shapes -> SVG shapes -> Path data shapes & Basic shapes.

Clone Layer

Layers can be cloned with its object by using the cloneLayer public method.This creates an identical copy of the layer and all its assigned elements.

Use case: Create template layers or duplicate complex layer configurations for reuse in different diagram sections.

The following code illustrates how clone the layer.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance;

let nodes= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 130,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 160,
        offsetY: 360,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

const cloneLayer = () => {
    /**
   * To Clone the layer
   * Parameter 1 - A string representing the name of the layer to be cloned.
   */
    diagramInstance.cloneLayer('layer1');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="cloneLayer" onClick={cloneLayer} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1','node2'],
            },
            {
                id: 'layer2',
                objects: ['node3'],
            },
        ]
    }
/>

</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, NodeModel } from "@syncfusion/ej2-react-diagrams";
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

let diagramInstance: DiagramComponent ;

let nodes: NodeModel[]= [
    {
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    
    {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 130,
        annotations: [{ content: 'Layer 1 Object' }],
    },
    
    {
        id: 'node3',
        width: 100,
        height: 100,
        offsetX: 160,
        offsetY: 360,
        annotations: [{ content: 'Layer 2 Object' }],
    },
];

const cloneLayer = () => {
    /**
   * To Clone the layer
   * Parameter 1 - A string representing the name of the layer to be cloned.
   */
    diagramInstance.cloneLayer('layer1');
}

// initialize diagram component
function App() {
return (
<div>
<ButtonComponent content="cloneLayer" onClick={cloneLayer} />
<DiagramComponent
  id="container"
  ref={(diagram) => (diagramInstance = diagram)}
  width={'100%'}
  height={'600px'}
  nodes={nodes}
  // Add layer
  layers = {
        [
            {
                id: 'layer1',
                objects: ['node1','node2'],
            },
            {
                id: 'layer2',
                objects: ['node3'],
            },
        ]
    }
/>

</div>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Active Layer

The active layer represents the layer with the highest z-index in a diagram. When objects are added at runtime, they are automatically assigned to the active layer. If no layers are explicitly defined, a default layer is created and set as the active layer. When multiple layers exist, the layer with the highest z-index becomes the active layer.

Use case: Ensure new elements are added to the appropriate layer in multi-layer diagrams, particularly in interactive editing scenarios.

Get ActiveLayer

Retrieve the current active layer of the diagram using the getActiveLayer public method.

The following code illustrates how fetch active layer from the diagram

    
// gets the active layer of diagram
diagram.getActiveLayer();

Set ActiveLayer

You can set any layer to be the active layer of the diagram by using the setActiveLayer public method.

The following code illustrates how to set active layer for diagram

// set the active layer
//@param layerName defines the name of the layer which is to be active layer
diagram.setActiveLayer('layer2');